#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
char obrz[8]; //pole obrazu zelen barvy
char obrc[8]; //pole obrazu erven barvy
char pozice[64];  //pole v kterm je uloeno jesi v danm umstn je/nen had
char pozice_ocasu[64]; //ukldaj se zasebou pozice kudy had proel
char *ukazz, *ukazc, *ocas, *hlava, *ukazj, *ukazd; //ukazatele ukazz -c pohybuje se v poli pro zobrazen ukazj -d ukazatele do pamti programu na vykreslovn sel skre
char cykl=0, jablko=0, hlavax, hlavay, bodyd, bodyj, mhlava; //cykl slou pro zobrazen jako aktuln dek. Ostatn jsou rzn potebn promnn pro funkci hada
int tik,i = 0; //tik pouit jako hodihy pro program odvozen z peteen T/C 0 a i je promnn pro cykly
char ocasx, ocasy, jablkox, jablkoy, smer, zahlaviy, zahlavix; // dal promn pro pozici hada

prog_char cisla[70] = {0x0d ,0x0a ,0x0a, 0x0a, 0x0a, 0x0a, 0x0d, 0x0e ,0x0e ,0x0e, 0x0e, 0x0a, 0x0c, 0x0e, 0x08 ,0x0b ,0x0d, 0x0e, 0x0e, 0x0a, 0x0d, 0x0d ,0x0a ,0x0e, 0x0d, 0x0e, 0x0a, 0x0d, 0x0e ,0x0e ,0x0e, 0x08, 0x0a, 0x0b, 0x0b, 0x0d ,0x0a ,0x0e, 0x0e, 0x08, 0x0b, 0x08, 0x0d ,0x0a ,0x0a, 0x09, 0x0b, 0x0b, 0x0c, 0x0b ,0x0b ,0x0d, 0x0d, 0x0e, 0x0e, 0x08, 0x0d ,0x0a ,0x0a, 0x0d, 0x0a, 0x0a, 0x0d, 0x09 ,0x0e ,0x0e, 0x0c, 0x0a, 0x0a, 0x0d}; 
// ve jsou bitmapov obrazy sel 0 - 9 uloen v pamti programu


int main (void)
{
  DDRB |= ((1 << 0) | (1 << 1) | (1 << 2));
  DDRA = 0xff; //vstup pro zelenou
  DDRC = 0xff; //vstup pro ervenou
  DDRD = 0x00;			//nastaven port jako vstupn/vstupn
  TIMSK |= (1 << TOIE0);
  TCCR0 |= ((1 << CS01) | (1 << CS00));  //nastaven asovae T/C0 aby piblin po 1ms petekl
  ukazz = &obrz[0];
  ukazc = &obrc[0]; //inicializace ukazatel na barevn obrazy displeje
  sei();    //povolen peruen

  while (1)    //nekonen smyka programu	
  {              //zatek inicializace hada i po prohe
 	  pozice[0]=0;  //tyto dva dky jsou aby se had nekousnul do ocasu tsn ped hlavou (had dlouh 8 bod me jet chodit v jednom smru
	  pozice_ocasu[0]=0;
    for (i = 1; i < 3;i++)  //inicializace pvodnho krtkho tla hada
	{
	  pozice[i]=1;
	  pozice_ocasu[i]=i;
	}
	for (i = 3; i < 64;i++) //inicializace zbytku pole
	{
	  pozice[i]=0;
	  pozice_ocasu[i]=0;
	}
	obrc[0]=0xf1;  //zobrazen krtkho hada
	obrz[0]=0xf7;
	for (i = 1; i < 8;i++) //zhasnut zbyl sti displeje
	{
	  obrc[i]=0xff;
	  obrz[i]=0xff;
	}
	hlavax=3;  //ostatn promnn, poloha, hodiny, smr...
	hlavay=0;
	bodyd=0;
	bodyj=0;
    tik = 0;
	mhlava=3;
	smer=0;
	ocas = &pozice_ocasu[0]; //poten poloha ocasu hada
	hlava = &pozice_ocasu[2]; //poten poloha hlava hada
	jablko=rand () % 64;	//poten generace jablka
	while (pozice[jablko]==1)//aby se jablko neobvilo v hadovi
	{
	  jablko=rand () % 64;
	}
		jablkoy=jablko;  //pepoten polohy jablka na souadnice na displeji
	    jablkox=0x07 & jablkoy;
	    jablkoy=jablkoy>>3;
        obrz[jablkoy] &= ~(1<<jablkox);  //zobrazen jablka
		
		
	while (pozice[mhlava]==0)	 //hlavn smyka, dokud had nenaraz do sebe (neprohrajeme) tak je program v n
	{
	  pozice[mhlava]=1; //pozice...pole bod displeje 1-64 do kterho pidme na msto hlavy pznak ptomnosti hada
	  hlava++;  //posunut ukazatele na hlavu o jedno pole
	  if (hlava > &pozice_ocasu[63]) //vce ne 64 bod had nebude mt tak sta jen pole 64B
	     hlava = &pozice_ocasu[0];
      *hlava = mhlava; //ulo pozici hlavy  do pole pamatujc si pozice hada
	  
	  if (mhlava==jablko) //je na pozici hlavy jablko?
	  {
	  if (bodyj <9) //piten bod
		{
		  bodyj++; //...jednotek...
		}
		else
		{
		  bodyd++;  //...a destek
		  bodyj=0;
		}
		jablko=rand () % 64;   //generovn novho jablka
	    while (pozice[jablko]==1)  //jesi je jablko v hadovi tak nov generovn
	    {
	      jablko=rand () % 64;
	    }
	    jablkoy=jablko;  //vpoet souadnic jablka
	    jablkox=0x07 & jablkoy;  //...x-ov...
	    jablkoy=jablkoy>>3;  //...a y-lonov souadnice
        obrz[jablkoy] &= ~(1<<jablkox);		//zobrazen jablka
	    ocas--;  //korekce zobrazovn ocasu, prodlouen hada o 1
	  }
	  	    
	  if(smer<2) //pohybuje-li se horizontln sta jen kontrolonat ipky nahoru a dol
	  while (tik<500)//skenovn tlatek podobu asi pl sekundy
	  {
	    if( bit_is_clear( PIND,1 )) //ipka dol
	      smer=3;
	    if( bit_is_clear( PIND,2 )) //ipka nahoru
	      smer=2;
      }	
	  else  //vertikln smr
	  while (tik<500)//skenovn tlatek podobu asi pl sekundy
	  {
	    if( bit_is_clear( PIND,3 )) //ipka  vlevo
	      smer=0;
	    if( bit_is_clear( PIND,0 )) //ipka vpravo
	      smer=1;
	  }
	  tik=0;  //vynulovn potadla peteen

	  zahlavix=hlavax; //uloen pvodnch souadnc hlavy pro zhasnut oranov hlavy
	  zahlaviy=hlavay;
	  switch (smer) //posun hada
	  {
	  case 0:  //vlevo
	    hlavax++;
	    if (hlavax>7)
	      hlavax =0;
		break;		 
	  case 1:  //vpravo
	    hlavax--;
		if (hlavax<0)
		  hlavax =7;
		break;
	  case 2:  //nahoru
		hlavay++;
		if (hlavay>7)
		  hlavay =0;
		break;
	  case 3:  //dol
		hlavay--;
		if (hlavay<0)
		  hlavay =7;
		break;
      }

      mhlava = hlavay<<3; //vpoet polohy hlavy
	  mhlava |= hlavax;	  
	  ocas++;      //posun ocasu
	  if (ocas > &pozice_ocasu[63] ) //aby ocas nepekroil rozsah pole
	    ocas = &pozice_ocasu[0];
      pozice[*ocas]=0;//odeten ocasu v poli pozic hada
	  ocasy=*ocas; //vpoet souadnic ocasu
	  ocasx=0x07 & ocasy; //...x-ov...
	  ocasy=ocasy>>3;//...a y-lonov
      
      obrc[ocasy] |=1<<ocasx;//zhasne diodu ocasu
      obrz[zahlaviy] |=1<<zahlavix;//udl z 2 lnku hada erven
	  obrc[hlavay] &= ~(1<<hlavax);//rohne oranovou hlavu
	  obrz[hlavay] &= ~(1<<hlavax);
	}   //konec hlavn smyky hry


    while (tik<2000);//nech svtit nabouranho hada cca 2sec
	ukazj=&cisla[0]+(7*bodyj);//nahraje do ukazatele jednotek skre poten dek odpovdajcho sla 
    ukazd=&cisla[0]+(7*bodyd);//nahraje do ukazatele destek skre poten dek odpovdajcho sla 
	for (i=0;i<7;i++)//zobraz skre
	{
	  obrz[i] = pgm_read_byte(ukazd)<<4;//prvn destky se nahrajou rovnou na tyi horn bity
	  obrz[i] |= pgm_read_byte(ukazj); //k tomu se pitou jednotky
	  obrc[i] = obrz[i]; //obraz bude oranov
	  ukazd++; //dal dek z bitmapy
	  ukazj++;
	}
     obrz[7] = 0xff;//zhasnut nevyuitho dku skre
     obrc[7] = 0xff;
     while (tik<800);//jen aby si uivatel uil alespo 800ms svho skre
	  tik=0;  
	  while (bit_is_set( PIND,3 )); //optovn sputn hry stiskem tlatka S1
  }
}

ISR(TIMER0_OVF_vect) //peteen tae/asovae0
{
  PORTB = cykl; //vybr pslunho dku
  PORTC = *ukazc; //zobrazen pslunho ervenho dku
  PORTA = *ukazz; //zobrazen pslunho zelenho dku
  cykl++;
  ukazc++;
  ukazz++;  // inkrementace na dal dek
  tik++;  // zven promnn kter se pouv jako vnirn hodiny
  if (cykl == 8)  //skok z poslednho dku znovu na prvn
  {
    cykl = 0;  //dek 0 :)
	ukazc = &obrc[0];
	ukazz = &obrz[0];  //ukazatele znovu na prvn dek
	
  }

 
}
